colormaps = require("termit.colormaps")
utils = require("termit.utils")

defaults = {}
defaults.windowTitle = 'Термит'
defaults.startMaximized = true
defaults.hideTitlebarWhenMaximized = true
defaults.tabName = 'Вкладка'
defaults.encoding = 'UTF-8'
defaults.wordCharExceptions = '- .,_/'
defaults.font = 'PT Mono 14'
--defaults.foregroundColor = 'gray'
defaults.backgroundColor = 'rgb(10, 10, 15)'
defaults.showScrollbar = true
defaults.hideSingleTab = false
defaults.hideTabbar = false
defaults.showBorder = true
defaults.hideMenubar = true
defaults.fillTabbar = false
defaults.scrollbackLines = 4096
defaults.geometry = '80x24'
defaults.allowChangingTitle = false
--defaults.backspaceBinding = 'AsciiBksp'
--defaults.deleteBinding = 'AsciiDel'
defaults.cursorBlinkMode = 'BlinkOff'
defaults.cursorShape = 'Ibeam'
defaults.tabPos = 'Right'
defaults.setStatusbar = function (tabInd)
    tab = tabs[tabInd]
    if tab then
        return tab.encoding..'  Bksp: '..tab.backspaceBinding..'  Del: '..tab.deleteBinding
    end
    return ''
end
defaults.colormap = colormaps.delicate
defaults.matches = {['http[^ ]+'] = function (url) print('Matching url: '..url) end}
defaults.tabs = {{title = 'Вкладка 1'; workingDir = '~'}}
defaults.wordChars = true
setOptions(defaults)

bindKey('Ctrl-F', findDlg)
bindKey('Ctrl-1', function () activateTab(1) end)
bindKey('Ctrl-2', function () activateTab(2) end)
bindKey('Ctrl-3', function () activateTab(3) end)
bindKey('Ctrl-4', function () activateTab(4) end)
bindKey('Ctrl-5', function () activateTab(5) end)
bindKey('Ctrl-6', function () activateTab(6) end)
bindKey('Ctrl-7', function () activateTab(7) end)
bindKey('Ctrl-8', function () activateTab(8) end)
bindKey('Ctrl-9', function () activateTab(9) end)
bindKey('Ctrl-0', function () activateTab(10) end)
-- don't close tab with Ctrl-w, use CtrlShift-w
bindKey('Ctrl-w', nil)
bindKey('CtrlShift-w', closeTab)
bindKey('Ctrl-t', nil)
bindKey('CtrlShift-n', openTab)
bindKey('Alt-Left', nil)
bindKey('Ctrl-k', nextTab)
bindKey('Alt-Right', nil)
bindKey('Ctrl-i', prevTab)
bindKey('Ctrl-Insert', nil)
bindKey('Ctrl-c', copy)
bindKey('Shift-Insert', nil)
bindKey('Ctrl-v', paste)
bindKey('Ctrl-l', loadSessionDlg)
bindKey('Ctrl-s', saveSessionDlg)
bindKey('Ctrl-p', preferencesDlg)
bindKey('Ctrl-d', closeTab)
bindKey('Ctrl-n', setTabTitleDlg)
bindKey('Ctrl-r', function () setTabForegroundColor('red') end)
bindKey('CtrlShift-r', reconfigure)
bindKey('CtrlShift-a', function () utils.dumpToFile(forEachRow, '/tmp/termit.all.dump') end)
bindKey('CtrlShift-p', function () utils.dumpToFile(forEachVisibleRow, '/tmp/termit.screenshort.dump') end)
bindKey('CtrlShift-m', toggleMenubar)
bindKey('CtrlShift-t', toggleTabbar)
bindKey('CtrlShift-Plus', function () changeTabFontSize(1) end)
bindKey('CtrlShift-Minus', function () changeTabFontSize(-1) end)
bindKey('CtrlShift-k', function () setTabPos(currentTabIndex() - 1) end)
bindKey('CtrlShift-i', function () setTabPos(currentTabIndex() + 1) end)
bindKey('Ctrl-q', quit)

--

setKbPolicy('keycode')
--setKbPolicy('keysym')

bindMouse('DoubleClick', openTab)

-- 
userMenu = {}
table.insert(userMenu, {name='Закрыть вкладку', action=closeTab, accel='Ctrl-d'})
table.insert(userMenu, {name='Переименовать вкладку', action=function () setTabTitleDlg() end, accel='Ctrl-n'})

mi = {}
mi.name = 'Вкладка Zsh'
mi.action = function ()
    tabInfo = {}
    tabInfo.title = 'Вкладка Zsh'
    tabInfo.command = 'bash'
    tabInfo.encoding = 'UTF-8'
    tabInfo.workingDir = '~'
    tabInfo.backspaceBinding = 'AsciiBksp'
    tabInfo.deleteBinding = 'EraseDel'
    openTab(tabInfo)
end
table.insert(userMenu, mi)

mi = {}
mi.name = 'Показать lua_api.txt'
mi.action = function ()
    tabInfo = {}
    tabInfo.name = 'lua_api.txt'
    tabInfo.command = 'less /usr/share/doc/termit/lua_api.txt'
    tabInfo.encoding = 'UTF-8'
    tabInfo.working_dir = '/tmp'
    openTab(tabInfo)
end
table.insert(userMenu, mi)

table.insert(userMenu, {name='Красный цвет шрифта', action=function () setTabForegroundColor('red') end, accel='Ctrl-r'})
table.insert(userMenu, {name='Перезагрузить', action=reconfigure, accel='CtrlShift-r'})
--table.insert(userMenu, {name='Выборка', action=function () print(selection()) end})
--table.insert(userMenu, {name='Выгрузить все строки', action=function () forEachRow(print) end})
table.insert(userMenu, {name='Выгрузить все строки в файл',
    action=function () utils.dumpToFile(forEachRow, '/tmp/termit.all.dump') end, accel='CtrlShift-a'})
table.insert(userMenu, {name='Выгрузить все видимые строки в файл',
    action=function () utils.dumpToFile(forEachVisibleRow, '/tmp/termit.screenshort.dump') end, accel='CtrlShuft-p'})
table.insert(userMenu, {name='Найти далее', action=findNext, accel='CtrlAlt-Up'})
table.insert(userMenu, {name='Найти ранее', action=findPrev, accel='CtrlAlt-Down'})
table.insert(userMenu, {name='Новая цветосхема', action=function () setColormap(colormaps.mikado) end, accel='CtrlShift-c'})
table.insert(userMenu, {name='Переключить плашку меню', action=function () toggleMenubar() end, accel='CtrlShift-m'})
table.insert(userMenu, {name='Переклчить плашку вкладок', action=function () toggleTabbar()  end, accel='CtrlShift-t'})

mi = {}
mi.name = 'Получить сведения о вкладке'
mi.action = function ()
    tab = tabs[currentTabIndex()]
    if tab then
        utils.printTable(tab, '  ')
    end
end
table.insert(userMenu, mi)

function round(float)
    return math.floor(float + .5)
end

function changeTabFontSize(delta)
    tab = tabs[currentTabIndex()]
    fontSize = round(tab.fontSize)
    setTabFont(string.sub(tab.font, 1, string.find(tab.font, '%d+$') - 1)..(fontSize + delta))
end

table.insert(userMenu, {name='Увеличить размер шрифта', action=function () changeTabFontSize(1) end})
table.insert(userMenu, {name='Уменьшить размер шрифта', action=function () changeTabFontSize(-1) end})
table.insert(userMenu, {name='Передвинуть вкладку вниз', action=function () setTabPos(currentTabIndex() - 1) end, accel='CtrlShift-k'})
table.insert(userMenu, {name='Передвинуть вкладку вверх', action=function () setTabPos(currentTabIndex() + 1) end, accel='CtrlShift-i'})
table.insert(userMenu, {name='Выйти', action=quit, accel='Ctrl-q'})

addMenu(userMenu, "Пользовательское меню")
addPopupMenu(userMenu, "Пользовательское меню")

